<?php

class admin_controller extends rpd_cms_controller {

	public function __construct()
	{
		parent::__construct();
		if (!in_array(rpd::$uri->get_uri(), array('admin/login','admin/login/process/1')) && !(rpd::$auth->logged()))
		{
			rpd::redirect("admin/login");
		}else{
      if ((rpd::$auth->user("role_id")!=1) || (rpd::$auth->user("role_id")!=1)){
        rpd::$auth->logout();
        rpd::redirect("log/in/next/admin");
      }
    }

	}

	public function login()
	{
		if ($this->auth->logged())
		{
			rpd::redirect("admin/index");
		} else {

			//form
			$form = new dataform_library();
			$form->field('input','user_','Username')->rule('required');
			$form->field('password','pass_','Password')->rule('required');
			$form->submit('save','login');
			$form->build();

			if ($form->on('show') OR $form->on('error'))
			{
				$output = $form->output;
			}

			if ($form->on('success'))
			{
				//is a valid user
				$valid_user = $this->auth->login($_POST["user_"], $_POST["pass_"]);
				rpd::redirect("admin/index");
			}

			$this->render($form->output);
		}
	}

	public function logout()
	{
		$this->auth->logout();
		rpd::redirect("admin/login");
	}

	public function index()
	{
		rpd::redirect('admin/dashboard');

	}

	public function dashboard()
	{

		//echo $this->render('<h2>Loggedin</h2>');
		$data['title']	= 'Dashboard';
		$data['content']= $this->view('admin_dashboard');
		echo $this->view('admin', $data);

	}
	
	public function main_js()
	{
		header("Content-type: text/javascript");
		echo $this->view('admin_main_js');
	}
	
	public function render($content)
	{
		$data['content'] = $content;
		//$data['modules'] = $this->modules;
		$data['logged'] = $this->auth->logged();
		$data['user'] = $this->auth->user();
		echo $this->view('admin', $data);
	}
	
	
	
	function upload_and_resize($width=560, $height=312, $folder='')
    {
		$file = current($_FILES);
		$dir = rtrim('/uploads/'.trim($folder,'/'),'/');

		//fare il sanitize del nome del file.. nella directori dove andrà savata
		$filename = $file['name'];
		$filename = preg_replace('/\s+/', '_', $filename);
		$filename = preg_replace('/[^a-zA-Z0-9\._-]/', '', $filename);

		$extension = strtolower(substr(strrchr($filename, '.'), 1));
		$name = rtrim($filename, strrchr($filename, '.'));

		$i = 0;
		$finalname = $name;
		while (file_exists($_SERVER['DOCUMENT_ROOT'].$dir . $finalname. '.'.$extension))
		{
				$i++;
				$finalname = $name . (string)$i;
		}
		$filename = $finalname. '.'.$extension;



		if($file['error'] == UPLOAD_ERR_OK)
		{
				if(@move_uploaded_file($file['tmp_name'], $_SERVER['DOCUMENT_ROOT'].$dir."/".$filename))
				{
						rpd_image_helper::crop($_SERVER['DOCUMENT_ROOT'].$dir.'/'.$filename, $_SERVER['DOCUMENT_ROOT'].$dir.'/'.$filename, $width, $height);
				}
		}

		$arr = array(
				'error'   => $file['error'],
				'file'    => $dir."/".$filename,
				'tmpfile' => $file['tmp_name'],
				'size'    => $file['size']
		);
		echo json_encode($arr);
    }
	

}
