<?php
class manuscripts_helper {
  public $blankhash;
  public $precursor;
  public $from;
  public $subject;
  public $date;
  
  public $text;
  
  function __construct(){
    $this->blankhash=sha1("");
  }
  
  function cachePut($path){
    $raw=$this->raw();
    return file_put_contents($path.sha1($raw),$raw);
  }
  
  function raw(){
    return ($this->precursor ? $this->precursor : $this->blankhash)."\r\n".$this->from."\r\n".$this->subject."\r\n".$this->date."\r\n\r\n".$this->crlf($this->text);  
  }
  
  function hash(){
    return sha1($this->raw());
  }
  
  
  function crlf($in){
    $in=str_replace("\r\n","\n",$in);
    $in=str_replace("\r","\n",$in);
    $in=str_replace("\n","\r\n",$in);
    return $in;
  }
  
  function parse($in){
    $l=explode("\r\n",$in);
    if (count($l)>5){
      $this->precursor=$l[0];
      $this->from=$l[1];
      $this->subject=$l[2];
      $this->date=$l[3];
      
      $this->text=implode("\r\n",array_slice($l,5));
      return true;
    }
    return false;
  }
}